/*
 * @(#)ParseCoverageLoggerUTest.java
 *
 * Copyright (C) 2003 Matt Albrecht
 * groboclown@users.sourceforge.net
 * http://groboutils.sourceforge.net
 *
 *  Permission is hereby granted, free of charge, to any person obtaining a
 *  copy of this software and associated documentation files (the "Software"),
 *  to deal in the Software without restriction, including without limitation
 *  the rights to use, copy, modify, merge, publish, distribute, sublicense,
 *  and/or sell copies of the Software, and to permit persons to whom the 
 *  Software is furnished to do so, subject to the following conditions:
 *
 *  The above copyright notice and this permission notice shall be included in 
 *  all copies or substantial portions of the Software. 
 *
 *  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR 
 *  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, 
 *  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL 
 *  THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER 
 *  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING 
 *  FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER 
 *  DEALINGS IN THE SOFTWARE.
 */

package net.sourceforge.groboutils.codecoverage.v2.compiler;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;
import net.sourceforge.groboutils.autodoc.v1.AutoDoc;


/**
 * Tests the ParseCoverageLogger class.
 *
 * @author    Matt Albrecht <a href="mailto:groboclown@users.sourceforge.net">groboclown@users.sourceforge.net</a>
 * @version   $Date: 2004/04/15 05:48:28 $
 * @since     January 13, 2003
 */
public class ParseCoverageLoggerUTest extends TestCase
{
    //-------------------------------------------------------------------------
    // Standard JUnit Class-specific declarations
    
    private static final Class THIS_CLASS = ParseCoverageLoggerUTest.class;
    private static final AutoDoc DOC = new AutoDoc( THIS_CLASS );
    
    public ParseCoverageLoggerUTest( String name )
    {
        super( name );
    }


    //-------------------------------------------------------------------------
    // Tests
    
    
    public void testConstructor1()
    {
        new ParseCoverageLogger();
    }
    
    
    public void testConstructor2()
    {
        try
        {
            new ParseCoverageLogger( null, null );
            fail( "Did not throw IllegalArgumentException." );
        }
        catch (IllegalArgumentException iae)
        {
            // test exception
        }
    }
    
    
    public void testConstructor3()
    {
        try
        {
            new ParseCoverageLogger( THIS_CLASS, null );
            fail( "Did not throw IllegalArgumentException." );
        }
        catch (IllegalArgumentException iae)
        {
            // test exception
        }
    }
    
    
    public void testConstructor4()
    {
        try
        {
            new ParseCoverageLogger( null, "" );
            fail( "Did not throw IllegalArgumentException." );
        }
        catch (IllegalArgumentException iae)
        {
            // test exception
        }
    }
    
    
    public void testConstructor5()
    {
        try
        {
            new ParseCoverageLogger( MyLogger.class, "not-exist" );
            fail( "Did not throw IllegalStateException." );
        }
        catch (IllegalStateException iae)
        {
            // test exception
        }
    }
    
    
    public void testConstructor6()
    {
        try
        {
            new ParseCoverageLogger( MyLogger.class, "bad1" );
            fail( "Did not throw IllegalStateException." );
        }
        catch (IllegalStateException iae)
        {
            // test exception
        }
    }
    
    
    public void testConstructor7()
    {
        try
        {
            new ParseCoverageLogger( MyLogger.class, "bad2" );
            fail( "Did not throw IllegalStateException." );
        }
        catch (IllegalStateException iae)
        {
            // test exception
        }
    }
    
    
    public void testConstructor8()
    {
        try
        {
            new ParseCoverageLogger( MyLogger.class, "bad3" );
            fail( "Did not throw IllegalStateException." );
        }
        catch (IllegalStateException iae)
        {
            // test exception
        }
    }
    
    
    public void testConstructor9()
    {
        try
        {
            new ParseCoverageLogger( MyLogger.class, "bad4" );
            fail( "Did not throw IllegalStateException." );
        }
        catch (IllegalStateException iae)
        {
            // test exception
        }
    }
    
    
    public void testConstructor10()
    {
        try
        {
            new ParseCoverageLogger( MyLogger.class, "bad5" );
            fail( "Did not throw IllegalStateException." );
        }
        catch (IllegalStateException iae)
        {
            // test exception
        }
    }
    
    
    public void testConstructor11()
    {
        try
        {
            new ParseCoverageLogger( MyLogger.class, "bad6" );
            fail( "Did not throw IllegalStateException." );
        }
        catch (IllegalStateException iae)
        {
            // test exception
        }
    }
    
    
    public void testConstructor12()
    {
        new ParseCoverageLogger( MyLogger.class, "good" );
    }
    
    
    public void testGetClassName1()
    {
        ParseCoverageLogger pcl = new ParseCoverageLogger(
            MyLogger.class, "good" );
        assertEquals(
            "Incorrect class name.",
            MyLogger.class.getName(),
            pcl.getClassName() );
    }
    
    
    public void testGetMethodName1()
    {
        ParseCoverageLogger pcl = new ParseCoverageLogger(
            MyLogger.class, "good" );
        assertEquals(
            "Incorrect method name.",
            "good",
            pcl.getMethodName() );
    }
    
    
    public void testGetMethodSignature1()
    {
        ParseCoverageLogger pcl = new ParseCoverageLogger(
            MyLogger.class, "good" );
        assertEquals(
            "Incorrect method signature.",
            "(Ljava/lang/String;SSS)V",
            pcl.getMethodSignature() );
    }
    
    
    
    //-------------------------------------------------------------------------
    // Helpers
    
    public static class MyLogger
    {
        public static void good( String s, short a, short b, short c )
        {
        }
        public static String bad1( String s, short a, short b, short c )
        {
            return "";
        }
        public void bad2( String s, short a, short b, short c )
        {
        }
        protected static void bad3( String s, short a, short b, short c )
        {
        }
        static void bad4( String s, short a, short b, short c )
        {
        }
        protected void bad5( String s, short a, short b, short c )
        {
        }
        void bad6( String s, short a, short b, short c )
        {
        }
    }
    
    
    //-------------------------------------------------------------------------
    // Standard JUnit declarations
    
    
    public static Test suite()
    {
        TestSuite suite = new TestSuite( THIS_CLASS );
        
        return suite;
    }
    
    public static void main( String[] args )
    {
        String[] name = { THIS_CLASS.getName() };
        
        // junit.textui.TestRunner.main( name );
        // junit.swingui.TestRunner.main( name );
        
        junit.textui.TestRunner.main( name );
    }
    
    
    /**
     * 
     * @exception Exception thrown under any exceptional condition.
     */
    protected void setUp() throws Exception
    {
        super.setUp();
        
        // set ourself up
    }
    
    
    /**
     * 
     * @exception Exception thrown under any exceptional condition.
     */
    protected void tearDown() throws Exception
    {
        // tear ourself down
        
        
        super.tearDown();
    }
}

